问题描述
给定一个整数数组 nums 和一个整数目标值 target,请你在该数组中找出 和为目标值 target 的那 两个 整数,并返回它们的数组下标。
你可以假设每种输入只会对应一个答案。但是,数组中同一个元素在答案里不能重复出现。
你可以按任意顺序返回答案。
示例 1:
输入:nums = [2,7,11,15], target = 9
输出:[0,1]
解释:因为 nums[0] + nums[1] == 9 ,返回 [0, 1] 。
示例 2:
输入:nums = [3,2,4], target = 6
输出:[1,2]
示例 3:
输入:nums = [3,3], target = 6
输出:[0,1]
提示:
2 <= nums.length <= 104
-109 <= nums[i] <= 109
-109 <= target <= 109
只会存在一个有效答案
进阶:你可以想出一个时间复杂度小于 O(n2) 的算法吗?
来源:力扣(LeetCode)
链接:leetcode-cn.com/problems/tw…
方法一:暴力枚举
思路及算法
最容易想到的方法是枚举数组中的每一个数 x,寻找数组中是否存在 target – x。
当我们使用遍历整个数组的方式寻找 target – x 时,需要注意到每一个位于 x 之前的元素都已经和 x 匹配过,因此不需要再进行匹配。而每一个元素不能被使用两次,所以我们只需要在 x 后面的元素中寻找 target – x。
代码
package com.burns.study.leetcode.learning.chapter1;/**
* Created by burns.
*
* @author <a href="http://www.esoon-soft.com/">burns</a>
* @date 2021/07/03 8:11
*/
/**
* 暴力枚举
* @ClassName TwoSum
* @Author Burns
* @DAte 2021/7/3 8:11
*/
public class TwoSum_1 {
public static void main(String[] args){
int[] nums = {2,7,11,15};
int target = 17;
int[] ints = twoSum(nums, target);
StringBuilder sb = new StringBuilder("检索结果下标:");
for (int i=0;i<ints.length;i++){
sb.append(ints[i]+"、");
}
System.out.println(sb);
}
public static int[] twoSum(int[] nums, int target) {
int n = nums.length;
//第一层循环下标从0到nums.length-1
for (int i = 0; i < n; ++i) {
//第二层循环下标从第一层循环的下一个数到nums.length-1
//tips:1、为啥不从和上一个相同的数字开始,审题,人家要求:数组中同一个元素在答案里不能重复出现。
//tips:2、为啥第二次循环不从下标0开始,原因是:1、增加循环次数,即增加时间复杂度2、需要增加判断i!=j这种情况,3、可能会输出[0,3]和[3,0],这两种情况是一个意思,只不过顺序不一样,所以需要去重
for (int j = i + 1; j < n; ++j) {
//判断第一层和第二次循环的数值相加是否等于目标值
if (nums[i] + nums[j] == target) {
return new int[]{i, j};
}
}
}
return new int[0];
}
}
复制代码
输出结果:
复杂度分析
时间复杂度:
O(N^2)其中 N是数组中的元素数量。最坏情况下数组中任意两个数都要被匹配一次。
空间复杂度:
O(1)。
方法二:哈希表
思路及算法
注意到方法一的时间复杂度较高的原因是寻找 target – x 的时间复杂度过高。因此,我们需要一种更优秀的方法,能够快速寻找数组中是否存在目标元素。如果存在,我们需要找出它的索引。使用哈希表,可以将寻找 target – x 的时间复杂度降低到从 O(N) 降低到 O(1)。
这样我们创建一个哈希表,对于每一个 x,我们首先查询哈希表中是否存在 target – x,然后将 x 插入到哈希表中,即可保证不会让 x 和自己匹配。
代码
package com.burns.study.leetcode.learning.chapter1;/**
* Created by burns.
*
* @author <a href="http://www.esoon-soft.com/">burns</a>
* @date 2021/07/03 8:11
*/
import java.util.HashMap;
import java.util.Map;
/**
哈希表
* @ClassName TwoSum
* @Author Burns
* @DAte 2021/7/3 8:11
*/
public class TwoSum_2 {
public static void main(String[] args){
int[] nums = {2,7,11,15};
int target = 17;
int[] ints = twoSum(nums, target);
StringBuilder sb = new StringBuilder("检索结果下标:");
for (int i=0;i<ints.length;i++){
sb.append(ints[i]+"、");
}
System.out.println(sb);
}
public static int[] twoSum(int[] nums, int target) {
//定义一个hashmap,其中key存放nums的每个数值,value存放nums的每个值的下标
Map<Integer, Integer> hashMap = new HashMap<Integer, Integer>();
//从头到尾遍历nums
for (int i = 0; i < nums.length; ++i) {
//判断map中是否存在一个数使target-当前数,如果存在则返回,如果不存在,则插入到map中。
if (hashMap.containsKey(target - nums[i])) {
return new int[]{hashMap.get(target - nums[i]), i};
}
hashMap.put(nums[i], i);
}
return new int[0];
}
}
复制代码
复杂度分析
时间复杂度:
O(N),其中 N 是数组中的元素数量。对于每一个元素 x,我们可以 O(1)地寻找 target – x。
空间复杂度:
O(N),其中 NN是数组中的元素数量。主要为哈希表的开销。
作者:LeetCode-Solution
链接:leetcode-cn.com/problems/tw…